/*http://en.wikipedia.org/wiki/Garbage_collection_%28computer_science%29*/
/*http://en.wikipedia.org/wiki/Free_list*/

#define NULE 0
#define MULE 8888

typedef struct NOiD_memory
{
	int id;
	int size;
	struct NOiD_memory * last;
	struct NOiD_memory * next;
} NOiD_memory;

typedef struct NOiD_yromem
{
	NOiD_memory * space;
	int id;
} NOiD_yromem;

/*after reading in wikipedia , i found similarity with Garbage Collection by John McCarthy*/
/*so i've invented nothing*/

NOiD_memory * NOiD_seg (void * noid_array, int noid_size)
{

	NOiD_memory * noid_header = (NOiD_memory*)noid_array;
	NOiD_memory * noid_new = (NOiD_memory*)(noid_array + sizeof(NOiD_memory));
	NOiD_yromem * noid_ender = (NOiD_yromem*)(noid_array + noid_size - sizeof(NOiD_yromem));
	noid_header->id = MULE;
	noid_header->size = noid_size;
	noid_header->last = noid_new;
	noid_header->next = noid_new;
	noid_new->id = MULE;
	noid_new->size = noid_size - sizeof(NOiD_memory);
	noid_new->last = noid_header;
	noid_new->next = noid_header;
	noid_ender->space = noid_header;
	noid_ender->id = MULE;
	return noid_header;
}

void * NOiD_alloc (NOiD_memory * noid_segment, int noid_size)
{
	if (noid_size < sizeof(NOiD_memory)+sizeof(NOiD_yromem))
	{
		noid_size = sizeof(NOiD_memory)+sizeof(NOiD_yromem);
	}
	NOiD_memory * noid_pivot = noid_segment->next;
	NOiD_memory * noid_enogh;
	while (noid_pivot != noid_segment)
	{
		if (noid_pivot->size - sizeof(NOiD_memory) > noid_size + sizeof(int))
		{
			noid_enogh = noid_pivot;
			noid_pivot = noid_segment->last;
		}
		noid_pivot = noid_pivot->next;
	}

	if (noid_enogh != 0)
	{
		NOiD_memory * noid_mov = (NOiD_memory*)((void*)noid_enogh + noid_size + sizeof(int));
		NOiD_yromem * noid_set = (NOiD_yromem*)((void*)noid_enogh + noid_enogh->size - sizeof(NOiD_yromem));
		void * noid_new = (void*) noid_enogh;

		noid_mov->id = noid_enogh->id;
		noid_mov->size = noid_enogh->size - noid_size - sizeof(int);
		noid_mov->last = noid_enogh->last;
		noid_mov->next = noid_enogh->next;
		noid_mov->last->next = noid_mov;
		noid_mov->next->last = noid_mov;

		noid_set->space = noid_mov;
		*(int*)noid_new = noid_size;
		noid_new = noid_new +sizeof(int);

		//debug debug debug debug debug debug
		*(int*)noid_new = 0;
		*(int*)(noid_new + sizeof(int)) = 0;
		*(int*)(noid_new + (sizeof(int) * 2)) = 0;
		//debug debug debug debug debug debug

		return noid_new;
	}
	return NULE;
}

void NOiD_free (NOiD_memory * noid_segment, void * noid_offset)
{
	int noid_size = *(int*)(noid_offset - sizeof(int));
	NOiD_memory * noid_new = (NOiD_memory*) (noid_offset - sizeof(int));
	NOiD_yromem * noid_end = (NOiD_yromem*) (noid_offset + noid_size - sizeof(NOiD_yromem));
	noid_new->id = MULE;
	noid_new->size = noid_size + sizeof(int);
	noid_new->last = noid_segment;
	noid_new->next = noid_segment->next;
	noid_new->last->next = noid_new;
	noid_new->next->last = noid_new;
	noid_end->id = MULE;
	noid_end->space = noid_new;
	if ((*(int*)(noid_offset + noid_size)) == MULE )
	{

		NOiD_memory * noid_forward = (NOiD_memory*)(noid_offset + noid_size);
		NOiD_yromem * noid_foreend = (NOiD_yromem*)((void*)noid_forward + noid_forward->size - sizeof(NOiD_yromem));
		noid_new->size = noid_new->size + noid_forward->size;
		noid_forward->next->last = noid_forward->last;
		noid_forward->last->next = noid_forward->next;
		noid_foreend->space = noid_new;
		//debug
		noid_end->id = 0;
		noid_end->space = 0;
		noid_forward->id = 0;
		noid_forward->size = 0;
		noid_forward->last = 0;
		noid_forward->next = 0;
		//debug
		noid_end = noid_foreend;
	}
	if ((*(int*)(noid_offset - (sizeof(int)*2))) == MULE )
	{
		NOiD_yromem * noid_backend = (NOiD_yromem*)(noid_offset - (sizeof(int)*2) - sizeof(void*));
		NOiD_memory * noid_bacward = noid_backend->space;

		noid_bacward->size = noid_bacward->size + noid_new->size;
		noid_new->next->last = noid_new->last;
		noid_new->last->next = noid_new->next;
		noid_end->space = noid_bacward;
		//debug
		noid_backend->id = 0;
		noid_backend->space = 0;
		noid_new->id = 0;
		noid_new->size = 0;
		noid_new->last = 0;
		noid_new->next = 0;
		//debug
		noid_new = noid_bacward;
	}
}

//================================================================================
//================================================================================
//================================================================================

/*http://en.wikipedia.org/wiki/Linked_list*/


typedef struct NOiD_node
{
	void * pack;
	struct NOiD_node * last;
	struct NOiD_node * next;
} NOiD_node;

NOiD_node * NOiD_create (NOiD_node * noid_src, void * noid_pack, void * noid_ptr)
{
	if (noid_ptr == 0)
	{	return 0;	}

	NOiD_node * noid_nud = (NOiD_node*) noid_ptr;
	noid_nud->pack = noid_pack;

	if (noid_src != 0)
	{
		noid_nud->last = noid_src;
		noid_nud->next = noid_src->next;
		noid_nud->last->next = noid_nud;
		noid_nud->next->last = noid_nud;
	}
	else
	{
		noid_nud->last = noid_nud;
		noid_nud->next = noid_nud;
	}

	return noid_nud;
}

void NOiD_destroy (NOiD_node * noid_src, NOiD_node * noid_nud)
{
	if ((noid_src == 0)||(noid_nud == 0))
	{	return;		}

	if (noid_src == noid_nud)
	{
		while ( noid_src != noid_src->next )
		{
			NOiD_destroy(noid_src,noid_src->next);
		}
	}

	noid_nud->last->next = noid_nud->next;
	noid_nud->next->last = noid_nud->last;

	noid_nud->pack = 0;
	noid_nud->last = 0;
	noid_nud->next = 0;
}

void * NOiD_loop (NOiD_node * noid_src)
/* all node will move around noid_src */
/* so its sure that youll get them all */
{
	NOiD_node * noid_nud = noid_src->next;

	noid_src->last->next = noid_src->next;
	noid_src->next->last = noid_src->last;

	noid_nud->next->last = noid_src;
	noid_src->next = noid_nud->next;

	noid_nud->next = noid_src;
	noid_src->last = noid_nud;


	return noid_nud->pack;
}


//================================================================================
//================================================================================
//================================================================================



typedef struct NOiD_agenda
{
	void * check;
	void (*func)(void);
	float time;		//intervale
	float wait;		//now + intervale
	float idle;		//before + interval - now;
	struct NOiD_agenda * last;
	struct NOiD_agenda * next;
} NOiD_agenda;


NOiD_agenda * NOiD_schedule (NOiD_agenda * noid_src, void (*noid_func)(void), float noid_timer, void * noid_ptr)
{
	if ((noid_ptr == 0)||(noid_func == 0))
	{	return 0;	}

	NOiD_agenda * noid_rendezvous = (NOiD_agenda *) noid_ptr;
	noid_rendezvous->check = noid_rendezvous;
	noid_rendezvous->func = noid_func;
	noid_rendezvous->time = noid_timer;
	noid_rendezvous->wait = 0;
	noid_rendezvous->idle = 0;

	if (noid_src == 0)
	{
		noid_rendezvous->last = noid_rendezvous;
		noid_rendezvous->next = noid_rendezvous;
	}
	else
	{
		noid_rendezvous->last = noid_src;
		noid_rendezvous->next = noid_src->next;
		noid_rendezvous->last->next = noid_rendezvous;
		noid_rendezvous->next->last = noid_rendezvous;
	}
	return noid_rendezvous;
}

void * NOiD_cancel (NOiD_agenda * noid_rendezvous)
{
	if (noid_rendezvous == 0)
	{	return 0;	}

	noid_rendezvous->last->next = noid_rendezvous->next;
	noid_rendezvous->next->last = noid_rendezvous->last;

	noid_rendezvous->check = 0;
	noid_rendezvous->func = 0;
	noid_rendezvous->time = 0;
	noid_rendezvous->wait = 0;
	noid_rendezvous->idle = 0;
	noid_rendezvous->last = 0;
	noid_rendezvous->next = 0;

	return noid_rendezvous;
}

float NOiD_do (NOiD_agenda * noid_src, float noid_now)
{
	//
	if ((noid_src == 0)||(noid_now == 0))
	{	return 0;	}
	//
	float noid_idle = 40;
	NOiD_agenda * noid_pivot = noid_src->next;
	while (noid_pivot != noid_src)
	{
		if (noid_pivot->wait == 0)
		{
			noid_pivot->wait = noid_now + noid_pivot->time;
			noid_pivot->idle = noid_pivot->wait;
		}
		else
		{
			if (noid_pivot->wait <= noid_now)
			{
				noid_pivot->func();
				noid_pivot->wait = noid_now + noid_pivot->time;
			}
			noid_pivot->idle = noid_pivot->wait - noid_now;
		}
		if (noid_idle > noid_pivot->idle)
		{
			noid_idle = noid_pivot->idle;
		}
		noid_pivot = noid_pivot->next;
	}

	return noid_idle;
}
